Attribute VB_Name = "MainModule"
Option Explicit

'Flag um zu wissen ob wir das Spiel hosten
Public bolWirHostenDasSpiel As Boolean
'Helper fr asynchrones abfragen der Host's
Public lngEnumAsync As Long
'Struktur fr die gefundenen Host's
Private Type HostFound
    AppDesc As DPN_APPLICATION_DESC
    AddressHost As String
    AddressDevice As String
    TimeLastFound As Long
End Type
'Array fr die gefundenen Host's
Public moHosts() As HostFound
'Anzahl der gefundenen Host's
Public mlHostCount As Long
'div. Declares zu API-Funktionen
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const WM_CLOSE = &H10

'Einstiegspunkt des Programmes
Public Sub Main()
    Randomize Time
    'DirectX und DirectPlay initialisieren
    If DXInit = False Then GoTo ErrOut
    mlHostCount = -1        'anzahl auf -1 setzen damit wir spter wissen das wir noch gar nicht gesucht haben
    ErstelleSpielArrays     'die verschiedenen Array's fr das Spiel werden mit den Startwerten initialisiert
    frmStartup.Show         'Fenster anzeigen
    Exit Sub
ErrOut:
    End
End Sub

'Server starten
Public Function StartServer(ByVal strSessionName As String, ByVal strPlayerName As String) As Boolean
    Dim myPlayerInfo As DPN_PLAYER_INFO
    Dim myAppDesc As DPN_APPLICATION_DESC
    On Error GoTo ErrOut
    bolWirHostenDasSpiel = True
    'ausfllen der Application-Description
    With myAppDesc
        .guidApplication = GameGUID 'eindeutige GUID
        .lMaxPlayers = 4 'maximal 10 Spieler sind erlaubt (inkl. dem Host)
        .SessionName = strSessionName 'Bezeichnung der Session
        .lFlags = .lFlags Or DPNSESSION_MIGRATE_HOST 'Flag das andere Client's die Host-Funktion bernehmen knnen
    End With
    myPlayerInfo.Name = strPlayerName 'Spieler Name
    myPlayerInfo.lInfoFlags = DPNINFO_NAME
    'Informationen vom Spieler setzen
    DPP.SetPeerInfo myPlayerInfo, DPNOP_SYNC
    'Chat hosten
    DPP.Host myAppDesc, DPA, DPNHOST_OKTOQUERYFORADDRESSING
    StartServer = True
    Exit Function
ErrOut:
    StartServer = False
End Function

'Da DirectPlay von DirectX 8 nur noch mit CallBack Events arbeitet
'muss dem Fenster mittels der API Funktion PostMessage die Nachricht
'geschickt werden das wir das Programm beenden wollen.
'Ansonsten knnte es zu einem Thread-Deadlock kommen da ja DirectPlay
'in einem eigenen Thread und unser Programm auch in einem
'eigenen Thread luft. Der DP-Thread wrde unter Umstnden auf
'das Ende vom Programm-Thread warten und umgekehrt.
Public Sub CloseForm(oForm As Form)
    PostMessage oForm.hwnd, WM_CLOSE, 0, 0
End Sub

'diese Funktion erlaubt anderen Thread's auch zu arbeiten
'und hlt unseren Programm-Thread am leben
'DirectPlay luft in einem eigenen Thread
Public Sub DoSleep(Optional ByVal lMilliSec As Long = 0)
    Sleep lMilliSec
    DoEvents
End Sub

