VERSION 5.00
Begin VB.Form frmDPEvents 
   BorderStyle     =   0  'Kein
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Label Label1 
      Caption         =   "Dieses Fenster beinhaltet nur die DirectPlay Events und keine Spiel-relevanten Teile !"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1935
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   4095
   End
End
Attribute VB_Name = "frmDPEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'CallBack Event's vom DirectPlay
Implements DirectPlay8Event

'DirectX 8 DirectPlay Event's
'====================================================================================================================
'da DirectPlay unter DirectX 8 nur noch mit Callback-Event's
'arbeitet mssen alle Event's implementiert werden.
'Auch wenn sich nicht benutzt werden.
'Sonst funktioniert unser Programm nicht.
Private Sub DirectPlay8Event_AddRemovePlayerGroup(ByVal lMsgID As Long, ByVal lPlayerID As Long, ByVal lGroupID As Long, fRejectMsg As Boolean)
End Sub

Private Sub DirectPlay8Event_AppDesc(fRejectMsg As Boolean)
End Sub

Private Sub DirectPlay8Event_AsyncOpComplete(dpnotify As DxVBLibA.DPNMSG_ASYNC_OP_COMPLETE, fRejectMsg As Boolean)
End Sub

'ConnectComplete Event
'dieses Event mssen wir auswerten um zu wissen ob wir
'uns zu dem Host verbinden konnten
Private Sub DirectPlay8Event_ConnectComplete(dpnotify As DxVBLibA.DPNMSG_CONNECT_COMPLETE, fRejectMsg As Boolean)
    frmStartup.mfGotEvent = True
    If dpnotify.hResultCode = DPNERR_SESSIONFULL Then
        'ops, schon zu viele Teilnehmer im Spiel
        'wir drfen nicht mehr dazu
        MsgBox "Die maximale Anzahl der Teilnehmer wurde erreicht." & vbCrLf & _
            "Bitte ein anderes Spiel whlen oder ein eigenes erstellen.", vbOKOnly Or vbInformation
        Exit Sub
    End If
    If dpnotify.hResultCode = DPNERR_HOSTREJECTEDCONNECTION Then
        MsgBox "Das Spiel ist schon gestartet worden." & vbCrLf & _
            "Du kannst nicht mehr mitspielen, whle ein anderes Spiel.", vbOKOnly Or vbInformation
        Exit Sub
    End If
    'juhuu, wir konnten uns zu dem Spiel verbinden
    frmStartup.mfConnectComplete = True
End Sub

Private Sub DirectPlay8Event_CreateGroup(ByVal lGroupID As Long, ByVal lOwnerID As Long, fRejectMsg As Boolean)
End Sub

'CreatePlayer Event
'dieses Event mssen wir auswerten um zu wissen ob
'ein neuer Teilnehmer dem Spiel beigetreten ist
'das Ereignis wird nur vom Host ausgewertet, der Erstellt einen Spieler
'und versendet die Liste aller Spieler an alle Clients
Private Sub DirectPlay8Event_CreatePlayer(ByVal lPlayerID As Long, fRejectMsg As Boolean)
    If bolWirHostenDasSpiel Then
        Dim dpPeer As DPN_PLAYER_INFO
        dpPeer = DPP.GetPeerInfo(lPlayerID)
        'der Flag DPNPLAYER_LOCAL hilft uns festzustellen ob wir es selbst sind
        'oder ein anderer Teilnehmer
        If (dpPeer.lPlayerFlags And DPNPLAYER_LOCAL) = DPNPLAYER_LOCAL Then
            intMeineArrayID = ErstelleNeuenSpieler(dpPeer.Name, lPlayerID)
        Else
            Call ErstelleNeuenSpieler(dpPeer.Name, lPlayerID)
        End If
        If bolDasSpielLaeuft = False Then frmStartup.ShowPlayer
        SendeSpielerListe
    End If
End Sub

Private Sub DirectPlay8Event_DestroyGroup(ByVal lGroupID As Long, ByVal lReason As Long, fRejectMsg As Boolean)
End Sub

'DestroyPlayer Event
'dieses Event mssen wir auswerten um zu wissen ob
'ein Teilnehmer das Spiel verlassen hat
'das Ereignis wird nur vom Host ausgewertet, der lscht den Spieler
'und versendet die Liste aller Spieler an alle Clients
Private Sub DirectPlay8Event_DestroyPlayer(ByVal lPlayerID As Long, ByVal lReason As Long, fRejectMsg As Boolean)
    Dim dpPeer As DPN_PLAYER_INFO
    If bolWirHostenDasSpiel Then
        dpPeer = DPP.GetPeerInfo(lPlayerID)
        If (dpPeer.lPlayerFlags And DPNPLAYER_LOCAL) = DPNPLAYER_LOCAL Then Exit Sub
        If bolDasSpielLaeuft Then
            SendeHostNachricht SpielerName(lPlayerID) & " hat das Spiel verlassen..."
            frmGame.UpdateChat SpielerName(lPlayerID) & " hat das Spiel verlassen..."
        End If
        LoescheSpielerAusArray lPlayerID
        SendeSpielerListe
        If bolDasSpielLaeuft = False Then frmStartup.ShowPlayer
    End If
End Sub

Private Sub DirectPlay8Event_EnumHostsQuery(dpnotify As DxVBLibA.DPNMSG_ENUM_HOSTS_QUERY, fRejectMsg As Boolean)
End Sub

'wir jedesmal ausgewertet wenn wir einen Host gefunden haben
Private Sub DirectPlay8Event_EnumHostsResponse(dpnotify As DxVBLibA.DPNMSG_ENUM_HOSTS_RESPONSE, fRejectMsg As Boolean)
    frmStartup.AddHostsToListBox dpnotify
End Sub

'HostMigrate Event
'dieses Event wird ausgewertet wenn der Teilnehmer
'mit der Host-Funktion das Spiel verlassen hat
'DirectPlay teilt automatisch dem nchsten die Host-Funktion zu.
'Wir knnen das mittels der PeerInfo und dem Flag DPNPLAYER_LOCAL feststellen
Private Sub DirectPlay8Event_HostMigrate(ByVal lNewHostID As Long, fRejectMsg As Boolean)
    Dim dpPeer As DPN_PLAYER_INFO
    dpPeer = DPP.GetPeerInfo(lNewHostID)
    'haben wir die Host-Funktion bekommen ?
    If (dpPeer.lPlayerFlags And DPNPLAYER_LOCAL) = DPNPLAYER_LOCAL Then
        bolWirHostenDasSpiel = True
        If bolDasSpielLaeuft Then
            frmGame.Caption = frmGame.Caption & " (HOST)"
        Else
            frmStartup.Caption = frmStartup.Caption & " (HOST)"
            frmStartup.cmd_StartGame.Visible = True
        End If
    End If
End Sub

'ein Spieler will sich zum Spiel verbinden
'wenn es schon luft, dann lehnen wir das ab
Private Sub DirectPlay8Event_IndicateConnect(dpnotify As DxVBLibA.DPNMSG_INDICATE_CONNECT, fRejectMsg As Boolean)
    If bolDasSpielLaeuft Then fRejectMsg = True
End Sub

Private Sub DirectPlay8Event_IndicatedConnectAborted(fRejectMsg As Boolean)
End Sub

Private Sub DirectPlay8Event_InfoNotify(ByVal lMsgID As Long, ByVal lNotifyID As Long, fRejectMsg As Boolean)
End Sub

'Receive Event
'na dieses Event mssen wir auf alle Flle auswerten
'sonst wissen wir nicht was im Spiel abluft
Private Sub DirectPlay8Event_Receive(dpnotify As DxVBLibA.DPNMSG_RECEIVE, fRejectMsg As Boolean)
    Dim lMsg As Long, lOffset As Long
    Dim dpPeer As DPN_PLAYER_INFO, sName As String
    Dim sChat As String
    Dim i As Integer
    Dim lngPID As Long
    Dim spid As Integer
    Dim fid As Integer
    Dim vonx As Integer, vony As Integer
    Dim nachx As Integer, nachy As Integer
    'im dpnotify steckt die Nachricht
    With dpnotify
        'als erstes brauchen wir die ID der Nachricht, sonst wissen wir ja gar nicht worum es geht
        GetDataFromBuffer .ReceivedData, lMsg, LenB(lMsg), lOffset
        Select Case lMsg
        'wir haben eine Liste aller Spieler bekommen
        Case MsgSpielerListe
            For i = 0 To 3
                GetDataFromBuffer .ReceivedData, SPIELER(i).DPlayID, LenB(SPIELER(i).DPlayID), lOffset
                SPIELER(i).Name = GetStringFromBuffer(.ReceivedData, lOffset)
                If SPIELER(i).DPlayID <> 0 Then
                    dpPeer = DPP.GetPeerInfo(SPIELER(i).DPlayID)
                    If bolDasSpielLaeuft = False Then
                        If (dpPeer.lPlayerFlags And DPNPLAYER_LOCAL) = DPNPLAYER_LOCAL Then
                            intMeineArrayID = i
                        End If
                    End If
                    SPIELER(i).Aktiv = True
                Else
                    SPIELER(i).Aktiv = False
                End If
            Next
            frmStartup.ShowPlayer
        'huch - das Spiel wurde vom Host gestartet - los gehts
        Case MsgSpielStart
            frmStartup.Hide
            frmGame.Show
            frmGame.tim_Game.Enabled = True
            frmGame.Caption = "[" & SPIELER(intMeineArrayID).Name & "] " & frmGame.Caption
            bolDasSpielLaeuft = True
        'eine Chat Nachricht ist angekommen
        Case MsgChat
            sChat = GetStringFromBuffer(.ReceivedData, lOffset)
            frmGame.UpdateChat "<" & SpielerName(dpnotify.idSender) & "> " & sChat
        'der Host schickt uns eine Nachricht (hui)
        Case MsgHost
            sChat = GetStringFromBuffer(.ReceivedData, lOffset)
            frmGame.UpdateChat sChat
        'ein anderer Spieler hat den Wrfel bekommen - mal gucken ob nicht vielleicht wir selbst
        Case MsgWuerfeluebergabe
            GetDataFromBuffer .ReceivedData, intWerHatDenWuerfel, LenB(intWerHatDenWuerfel), lOffset
            If intWerHatDenWuerfel = intMeineArrayID Then
                frmGame.UpdateChat "Du hast den Wrfel !"
                frmGame.lbl_Spieler.Caption = "Du hast den Wrfel !"
                frmGame.cmd_Wrfel.Visible = True
            Else
                frmGame.UpdateChat SPIELER(intWerHatDenWuerfel).Name & " hat den Wrfel !"
                frmGame.lbl_Spieler.Caption = SPIELER(intWerHatDenWuerfel).Name & " hat den Wrfel !"
            End If
        'ein anderer Spieler hat gewrfelt und wir bekommen eine Nachricht was
        Case MsgWuerfelzahl
            GetDataFromBuffer .ReceivedData, i, LenB(i), lOffset
            frmGame.UpdateChat SpielerName(.idSender) & " hat eine " & i & " gewrfelt !"
        'ein Spieler hat eine Figur bewegt, na das wollen wir auch wissen
        Case MsgZug
            GetDataFromBuffer .ReceivedData, spid, LenB(spid), lOffset
            GetDataFromBuffer .ReceivedData, fid, LenB(fid), lOffset
            GetDataFromBuffer .ReceivedData, vonx, LenB(vonx), lOffset
            GetDataFromBuffer .ReceivedData, vony, LenB(vony), lOffset
            GetDataFromBuffer .ReceivedData, nachx, LenB(nachx), lOffset
            GetDataFromBuffer .ReceivedData, nachy, LenB(nachy), lOffset
            SPIELER(spid).ZugVon(fid).X = vonx
            SPIELER(spid).ZugVon(fid).Y = vony
            SPIELER(spid).ZugNach(fid).X = nachx
            SPIELER(spid).ZugNach(fid).Y = nachy
            ZugDurchfuehren spid, fid
        'ein Spieler hat gewonnen (heul - nicht wir)
        Case MsgGewonnen
            frmGame.UpdateChat SpielerName(.idSender) & " hat gewonnen !"
            frmGame.lbl_Spieler.Caption = SpielerName(.idSender) & " hat gewonnen !"
            frmGame.cmd_Finish.Visible = False
        End Select
    End With
End Sub

Private Sub DirectPlay8Event_SendComplete(dpnotify As DxVBLibA.DPNMSG_SEND_COMPLETE, fRejectMsg As Boolean)
End Sub

'TerminateSession Event
'dieses Event werten wir zur Sicherheit aus
'falls aus irgendeinem Grund die Verbindung abgebrochen ist
Private Sub DirectPlay8Event_TerminateSession(dpnotify As DxVBLibA.DPNMSG_TERMINATE_SESSION, fRejectMsg As Boolean)
    If dpnotify.hResultCode = DPNERR_HOSTTERMINATEDSESSION Then
        MsgBox "Der Host hat die Session beendet. Das Programm wird beendet.", vbOKOnly Or vbInformation
    Else
        MsgBox "Die Verbindung ist abgebrochen. Das Programm wird beendet.", vbOKOnly Or vbInformation
    End If
    CloseForm Me
End Sub

